// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from social_nav_msgs:msg/Pedestrian.idl
// generated code does not contain a copyright notice

#ifndef SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIAN__STRUCT_H_
#define SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIAN__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'identifier'
#include "rosidl_runtime_c/string.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose2_d__struct.h"
// Member 'velocity'
#include "nav_2d_msgs/msg/detail/twist2_d__struct.h"

/// Struct defined in msg/Pedestrian in the package social_nav_msgs.
typedef struct social_nav_msgs__msg__Pedestrian
{
  rosidl_runtime_c__String identifier;
  /// pose and velocity are relative to the same frame
  /// i.e. if a pedestrian starts at x=1, y=0, facing positive y (i.e. theta=90deg)
  ///      and was walking forward at 1 m/s, the velocity should be x=0, y=1, theta=0
  geometry_msgs__msg__Pose2D pose;
  nav_2d_msgs__msg__Twist2D velocity;
} social_nav_msgs__msg__Pedestrian;

// Struct for a sequence of social_nav_msgs__msg__Pedestrian.
typedef struct social_nav_msgs__msg__Pedestrian__Sequence
{
  social_nav_msgs__msg__Pedestrian * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} social_nav_msgs__msg__Pedestrian__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIAN__STRUCT_H_
