// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from social_nav_msgs:msg/Pedestrian.idl
// generated code does not contain a copyright notice

#ifndef SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIAN__STRUCT_HPP_
#define SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIAN__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose2_d__struct.hpp"
// Member 'velocity'
#include "nav_2d_msgs/msg/detail/twist2_d__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__social_nav_msgs__msg__Pedestrian __attribute__((deprecated))
#else
# define DEPRECATED__social_nav_msgs__msg__Pedestrian __declspec(deprecated)
#endif

namespace social_nav_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Pedestrian_
{
  using Type = Pedestrian_<ContainerAllocator>;

  explicit Pedestrian_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_init),
    velocity(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->identifier = "";
    }
  }

  explicit Pedestrian_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : identifier(_alloc),
    pose(_alloc, _init),
    velocity(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->identifier = "";
    }
  }

  // field types and members
  using _identifier_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _identifier_type identifier;
  using _pose_type =
    geometry_msgs::msg::Pose2D_<ContainerAllocator>;
  _pose_type pose;
  using _velocity_type =
    nav_2d_msgs::msg::Twist2D_<ContainerAllocator>;
  _velocity_type velocity;

  // setters for named parameter idiom
  Type & set__identifier(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->identifier = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::Pose2D_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__velocity(
    const nav_2d_msgs::msg::Twist2D_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    social_nav_msgs::msg::Pedestrian_<ContainerAllocator> *;
  using ConstRawPtr =
    const social_nav_msgs::msg::Pedestrian_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<social_nav_msgs::msg::Pedestrian_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<social_nav_msgs::msg::Pedestrian_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      social_nav_msgs::msg::Pedestrian_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<social_nav_msgs::msg::Pedestrian_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      social_nav_msgs::msg::Pedestrian_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<social_nav_msgs::msg::Pedestrian_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<social_nav_msgs::msg::Pedestrian_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<social_nav_msgs::msg::Pedestrian_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__social_nav_msgs__msg__Pedestrian
    std::shared_ptr<social_nav_msgs::msg::Pedestrian_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__social_nav_msgs__msg__Pedestrian
    std::shared_ptr<social_nav_msgs::msg::Pedestrian_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Pedestrian_ & other) const
  {
    if (this->identifier != other.identifier) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    return true;
  }
  bool operator!=(const Pedestrian_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Pedestrian_

// alias to use template instance with default allocator
using Pedestrian =
  social_nav_msgs::msg::Pedestrian_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace social_nav_msgs

#endif  // SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIAN__STRUCT_HPP_
