// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from social_nav_msgs:msg/Pedestrian.idl
// generated code does not contain a copyright notice

#ifndef SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIAN__TRAITS_HPP_
#define SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIAN__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "social_nav_msgs/msg/detail/pedestrian__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose2_d__traits.hpp"
// Member 'velocity'
#include "nav_2d_msgs/msg/detail/twist2_d__traits.hpp"

namespace social_nav_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Pedestrian & msg,
  std::ostream & out)
{
  out << "{";
  // member: identifier
  {
    out << "identifier: ";
    rosidl_generator_traits::value_to_yaml(msg.identifier, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
    out << ", ";
  }

  // member: velocity
  {
    out << "velocity: ";
    to_flow_style_yaml(msg.velocity, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Pedestrian & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: identifier
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "identifier: ";
    rosidl_generator_traits::value_to_yaml(msg.identifier, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }

  // member: velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity:\n";
    to_block_style_yaml(msg.velocity, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Pedestrian & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace social_nav_msgs

namespace rosidl_generator_traits
{

[[deprecated("use social_nav_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const social_nav_msgs::msg::Pedestrian & msg,
  std::ostream & out, size_t indentation = 0)
{
  social_nav_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use social_nav_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const social_nav_msgs::msg::Pedestrian & msg)
{
  return social_nav_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<social_nav_msgs::msg::Pedestrian>()
{
  return "social_nav_msgs::msg::Pedestrian";
}

template<>
inline const char * name<social_nav_msgs::msg::Pedestrian>()
{
  return "social_nav_msgs/msg/Pedestrian";
}

template<>
struct has_fixed_size<social_nav_msgs::msg::Pedestrian>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<social_nav_msgs::msg::Pedestrian>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<social_nav_msgs::msg::Pedestrian>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIAN__TRAITS_HPP_
