// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from social_nav_msgs:msg/Pedestrians.idl
// generated code does not contain a copyright notice
#include "social_nav_msgs/msg/detail/pedestrians__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `pedestrians`
#include "social_nav_msgs/msg/detail/pedestrian__functions.h"

bool
social_nav_msgs__msg__Pedestrians__init(social_nav_msgs__msg__Pedestrians * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    social_nav_msgs__msg__Pedestrians__fini(msg);
    return false;
  }
  // pedestrians
  if (!social_nav_msgs__msg__Pedestrian__Sequence__init(&msg->pedestrians, 0)) {
    social_nav_msgs__msg__Pedestrians__fini(msg);
    return false;
  }
  return true;
}

void
social_nav_msgs__msg__Pedestrians__fini(social_nav_msgs__msg__Pedestrians * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // pedestrians
  social_nav_msgs__msg__Pedestrian__Sequence__fini(&msg->pedestrians);
}

bool
social_nav_msgs__msg__Pedestrians__are_equal(const social_nav_msgs__msg__Pedestrians * lhs, const social_nav_msgs__msg__Pedestrians * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // pedestrians
  if (!social_nav_msgs__msg__Pedestrian__Sequence__are_equal(
      &(lhs->pedestrians), &(rhs->pedestrians)))
  {
    return false;
  }
  return true;
}

bool
social_nav_msgs__msg__Pedestrians__copy(
  const social_nav_msgs__msg__Pedestrians * input,
  social_nav_msgs__msg__Pedestrians * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // pedestrians
  if (!social_nav_msgs__msg__Pedestrian__Sequence__copy(
      &(input->pedestrians), &(output->pedestrians)))
  {
    return false;
  }
  return true;
}

social_nav_msgs__msg__Pedestrians *
social_nav_msgs__msg__Pedestrians__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  social_nav_msgs__msg__Pedestrians * msg = (social_nav_msgs__msg__Pedestrians *)allocator.allocate(sizeof(social_nav_msgs__msg__Pedestrians), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(social_nav_msgs__msg__Pedestrians));
  bool success = social_nav_msgs__msg__Pedestrians__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
social_nav_msgs__msg__Pedestrians__destroy(social_nav_msgs__msg__Pedestrians * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    social_nav_msgs__msg__Pedestrians__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
social_nav_msgs__msg__Pedestrians__Sequence__init(social_nav_msgs__msg__Pedestrians__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  social_nav_msgs__msg__Pedestrians * data = NULL;

  if (size) {
    data = (social_nav_msgs__msg__Pedestrians *)allocator.zero_allocate(size, sizeof(social_nav_msgs__msg__Pedestrians), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = social_nav_msgs__msg__Pedestrians__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        social_nav_msgs__msg__Pedestrians__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
social_nav_msgs__msg__Pedestrians__Sequence__fini(social_nav_msgs__msg__Pedestrians__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      social_nav_msgs__msg__Pedestrians__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

social_nav_msgs__msg__Pedestrians__Sequence *
social_nav_msgs__msg__Pedestrians__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  social_nav_msgs__msg__Pedestrians__Sequence * array = (social_nav_msgs__msg__Pedestrians__Sequence *)allocator.allocate(sizeof(social_nav_msgs__msg__Pedestrians__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = social_nav_msgs__msg__Pedestrians__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
social_nav_msgs__msg__Pedestrians__Sequence__destroy(social_nav_msgs__msg__Pedestrians__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    social_nav_msgs__msg__Pedestrians__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
social_nav_msgs__msg__Pedestrians__Sequence__are_equal(const social_nav_msgs__msg__Pedestrians__Sequence * lhs, const social_nav_msgs__msg__Pedestrians__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!social_nav_msgs__msg__Pedestrians__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
social_nav_msgs__msg__Pedestrians__Sequence__copy(
  const social_nav_msgs__msg__Pedestrians__Sequence * input,
  social_nav_msgs__msg__Pedestrians__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(social_nav_msgs__msg__Pedestrians);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    social_nav_msgs__msg__Pedestrians * data =
      (social_nav_msgs__msg__Pedestrians *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!social_nav_msgs__msg__Pedestrians__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          social_nav_msgs__msg__Pedestrians__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!social_nav_msgs__msg__Pedestrians__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
