// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from social_nav_msgs:msg/Pedestrians.idl
// generated code does not contain a copyright notice

#ifndef SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIANS__TRAITS_HPP_
#define SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIANS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "social_nav_msgs/msg/detail/pedestrians__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'pedestrians'
#include "social_nav_msgs/msg/detail/pedestrian__traits.hpp"

namespace social_nav_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Pedestrians & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: pedestrians
  {
    if (msg.pedestrians.size() == 0) {
      out << "pedestrians: []";
    } else {
      out << "pedestrians: [";
      size_t pending_items = msg.pedestrians.size();
      for (auto item : msg.pedestrians) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Pedestrians & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: pedestrians
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.pedestrians.size() == 0) {
      out << "pedestrians: []\n";
    } else {
      out << "pedestrians:\n";
      for (auto item : msg.pedestrians) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Pedestrians & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace social_nav_msgs

namespace rosidl_generator_traits
{

[[deprecated("use social_nav_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const social_nav_msgs::msg::Pedestrians & msg,
  std::ostream & out, size_t indentation = 0)
{
  social_nav_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use social_nav_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const social_nav_msgs::msg::Pedestrians & msg)
{
  return social_nav_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<social_nav_msgs::msg::Pedestrians>()
{
  return "social_nav_msgs::msg::Pedestrians";
}

template<>
inline const char * name<social_nav_msgs::msg::Pedestrians>()
{
  return "social_nav_msgs/msg/Pedestrians";
}

template<>
struct has_fixed_size<social_nav_msgs::msg::Pedestrians>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<social_nav_msgs::msg::Pedestrians>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<social_nav_msgs::msg::Pedestrians>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIANS__TRAITS_HPP_
