// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from social_nav_msgs:msg/Pedestrians.idl
// generated code does not contain a copyright notice

#ifndef SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIANS__FUNCTIONS_H_
#define SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIANS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "social_nav_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "social_nav_msgs/msg/detail/pedestrians__struct.h"

/// Initialize msg/Pedestrians message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * social_nav_msgs__msg__Pedestrians
 * )) before or use
 * social_nav_msgs__msg__Pedestrians__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
bool
social_nav_msgs__msg__Pedestrians__init(social_nav_msgs__msg__Pedestrians * msg);

/// Finalize msg/Pedestrians message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
void
social_nav_msgs__msg__Pedestrians__fini(social_nav_msgs__msg__Pedestrians * msg);

/// Create msg/Pedestrians message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * social_nav_msgs__msg__Pedestrians__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
social_nav_msgs__msg__Pedestrians *
social_nav_msgs__msg__Pedestrians__create();

/// Destroy msg/Pedestrians message.
/**
 * It calls
 * social_nav_msgs__msg__Pedestrians__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
void
social_nav_msgs__msg__Pedestrians__destroy(social_nav_msgs__msg__Pedestrians * msg);

/// Check for msg/Pedestrians message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
bool
social_nav_msgs__msg__Pedestrians__are_equal(const social_nav_msgs__msg__Pedestrians * lhs, const social_nav_msgs__msg__Pedestrians * rhs);

/// Copy a msg/Pedestrians message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
bool
social_nav_msgs__msg__Pedestrians__copy(
  const social_nav_msgs__msg__Pedestrians * input,
  social_nav_msgs__msg__Pedestrians * output);

/// Initialize array of msg/Pedestrians messages.
/**
 * It allocates the memory for the number of elements and calls
 * social_nav_msgs__msg__Pedestrians__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
bool
social_nav_msgs__msg__Pedestrians__Sequence__init(social_nav_msgs__msg__Pedestrians__Sequence * array, size_t size);

/// Finalize array of msg/Pedestrians messages.
/**
 * It calls
 * social_nav_msgs__msg__Pedestrians__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
void
social_nav_msgs__msg__Pedestrians__Sequence__fini(social_nav_msgs__msg__Pedestrians__Sequence * array);

/// Create array of msg/Pedestrians messages.
/**
 * It allocates the memory for the array and calls
 * social_nav_msgs__msg__Pedestrians__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
social_nav_msgs__msg__Pedestrians__Sequence *
social_nav_msgs__msg__Pedestrians__Sequence__create(size_t size);

/// Destroy array of msg/Pedestrians messages.
/**
 * It calls
 * social_nav_msgs__msg__Pedestrians__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
void
social_nav_msgs__msg__Pedestrians__Sequence__destroy(social_nav_msgs__msg__Pedestrians__Sequence * array);

/// Check for msg/Pedestrians message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
bool
social_nav_msgs__msg__Pedestrians__Sequence__are_equal(const social_nav_msgs__msg__Pedestrians__Sequence * lhs, const social_nav_msgs__msg__Pedestrians__Sequence * rhs);

/// Copy an array of msg/Pedestrians messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_social_nav_msgs
bool
social_nav_msgs__msg__Pedestrians__Sequence__copy(
  const social_nav_msgs__msg__Pedestrians__Sequence * input,
  social_nav_msgs__msg__Pedestrians__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // SOCIAL_NAV_MSGS__MSG__DETAIL__PEDESTRIANS__FUNCTIONS_H_
